--  MageTaxi --
-- Created by: ChaosInc --
-- (c) 2008-2010 Joshua Mrozek , All rights reserved.

MageTaxi = MageTaxi or CreateFrame("Frame")
MageTaxi:SetScript("OnEvent", function(self, event, ...) if MageTaxi[event] then return MageTaxi[event](self, event, ...) end end)
MageTaxi:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE")
MageTaxi:RegisterEvent("PLAYER_ENTERING_WORLD")
MageTaxi:RegisterEvent("ADDON_LOADED")
MageTaxi:Show()

function MageTaxi:CHAT_MSG_CHANNEL_NOTICE()
	currentLoc = GetZoneText()
	trade = GetChannelName("Trade - City")
end

function MageTaxi:PLAYER_ENTERING_WORLD()
	currentLoc = GetZoneText()
	trade = GetChannelName("Trade - City")
end

function MageTaxi:ADDON_LOADED(_,addon)
	if addon ~= "MageTaxi" then return end
	MageTaxi_Vars = MageTaxi_Vars or {}
	MageTaxi_Vars.price = MageTaxi_Vars.price or 10
	MageTaxi_Vars.travel = MageTaxi_Vars.travel or 15
	MageTaxi_Vars.add = MageTaxi_Vars.add or 5
	SLASH_MAGETAXI1 = "/magetaxi"
	SLASH_MAGETAXI2 = "/mtaxi"
	SlashCmdList["MAGETAXI"] = MageTaxi_createGUI
	self:SetFaction()
end

-- PORTAL SPELLS --
local portalSpells = {
	[1] = "Portal: Stormwind",
	[2] = "Portal: Ironforge",
	[3] = "Portal: Darnassus",
	[4] = "Portal: Exodar",
	[5] = "Portal: Theramore",
	[6] = "Portal: Shattrath",
	[7] = "Portal: Dalaran",
	[8] = "Portal: Undercity",
	[9] = "Portal: Orgrimmar",
	[10] = "Portal: Thunder Bluff",
	[11] = "Portal: Silvermoon",
	[12] = "Portal: Stonard",
	[13] = "Portal: Tol Barad"
	}
	
-- SET CITIES --
function MageTaxi:SetFaction()
	if UnitFactionGroup("player") == "Alliance" then
		cityList = {
			[1] = "Stormwind",
			[2] = "Ironforge",
			[3] = "Darnassus",
			[4] = "Exodar",
			[5] = "Theramore",
			[6] = "Shattrath",
			[7] = "Dalaran",
			[8] = "TolBarad",
		}
	else
		cityList = {
			[1] = "Undercity",
			[2] = "Orgrimmar",
			[3] = "ThunderBluff",
			[4] = "Silvermoon",
			[5] = "Stonard",
			[6] = "Shattrath",
			[7] = "Dalaran",
			[8] = "TolBarad",
		}
	end
end

function MageTaxi_createGUI()
	if MageTaxi_Config then MageTaxi_Config:Show() return end
	
	local f = CreateFrame("FRAME", "MageTaxi_Config")
		f:SetWidth(250)
		f:SetHeight(160)
		f:SetPoint("CENTER")
		f:SetBackdrop({
			bgFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-StatsBackground",
			edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			tile = "false",
			tileSize = 32,
			edgeSize = 10,
			insets = {left = 3, right = 3, top = 3, bottom = 3}
			})
		--f:SetBackdropColor(.25,.1,.25)
		--f:SetBackdropBorderColor(0,.5,0)
		f:EnableMouse(true)
		f:SetMovable(true)
		f:SetClampedToScreen(true)
		f:RegisterForDrag("LeftButton")
		f:SetScript("OnDragStart", f.StartMoving)
		f:SetScript("OnDragStop", f.StopMovingOrSizing)
		f:SetScript("OnShow", function()
			currentLoc = GetZoneText()
			end)
		tinsert(UISpecialFrames,"MageTaxi_Config")
	
	-- SPAM BUTTON -- 
	b = CreateFrame("BUTTON", "MageTaxiSpamButton", f, "OptionsButtonTemplate")
		b:SetText("Spam")
		b:SetWidth(78)
		b:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 5, 5)
		b:RegisterForClicks("LeftButtonUp")
		b:SetNormalFontObject("GameFontNormalSmall")
		b:SetHighlightFontObject("GameFontWhiteSmall")
		b:SetScript("OnClick", function()
			if dest == "none" then
				print("You have no destination selected or have no known ports.")
				return
			end
			msg = "MageTaxi: WTS portals to ".. dest.. " from ".. currentLoc.. ", "..MageTaxi_PriceBox:GetText().. "g.  ".. MageTaxi_TravelBox:GetText().. "g for me to come to another city."
			--SendChatMessage(msg, "WHISPER", nil, "ChaosInc")
			SendChatMessage(msg, "CHANNEL", nil, trade)
			end)
			
	-- LFM BUTTONS --
	b = CreateFrame("BUTTON", "MageTaxiLFMButton", f, "OptionsButtonTemplate")
		b:SetText("LFM")
		b:SetWidth(78)
		b:SetPoint("LEFT", MageTaxiSpamButton, "RIGHT", 2, 0)
		b:RegisterForClicks("LeftButtonUp")
		b:SetNormalFontObject("GameFontNormalSmall")
		b:SetHighlightFontObject("GameFontWhiteSmall")
		b:SetScript("OnClick", function()
			if dest == "none" then
				print("You have no destination selected or have no known ports.")
				return
			end
			more = "MageTaxi: Port requested to ".. dest.. " from ".. currentLoc.. ", PST to be included for ".. MageTaxi_AddBox:GetText().. "g."
			SendChatMessage(more, "CHANNEL", nil, trade)
			--SendChatMessage(more, "WHISPER", nil, "ChaosInc")
			end)
		
	-- LAST CALL BUTTON --
	b = CreateFrame("BUTTON", "MageTaxiLastButton", f, "OptionsButtonTemplate")
		b:SetText("Last Call")
		b:SetWidth(78)
		b:SetPoint("LEFT", MageTaxiLFMButton, "RIGHT", 2, 0)
		b:RegisterForClicks("LeftButtonUp")
		b:SetNormalFontObject("GameFontNormalSmall")
		b:SetHighlightFontObject("GameFontWhiteSmall")
		b:SetScript("OnClick", function()
			if dest == "none" then
				print("You have no destination selected or have no known ports.")
				return
			end
			lastCall = "MageTaxi: LAST CALL: Porting from ".. currentLoc.. " to ".. dest.. ", PST to be included for ".. MageTaxi_AddBox:GetText().. "g."
			SendChatMessage(lastCall, "CHANNEL", nil, trade)
			--SendChatMessage(lastCall, "WHISPER", nil, "ChaosInc")
			end)
	
	-- RADIO BUTTONS --
	for i = 1,#cityList do
		cb = CreateFrame("CHECKBUTTON", "MageTaxi_City"..i, f, "UIRadioButtonTemplate")
			if i == 1 then
				cb:SetPoint("TOPLEFT", f, "TOPLEFT", 30, -10)
			elseif i == 5 then
				cb:SetPoint("TOP", f, "TOP", 30, -10)
			else
				cb:SetPoint("TOP", "MageTaxi_City".. (i-1), "BOTTOM", 0, -10)
			end
			cb.text = cityList[i]
			cb:SetScript("OnClick", function(self)
				for num= 1,#cityList do
					_G["MageTaxi_City".. num]:SetChecked(false)
				end
				dest = cityList[i]
				self:SetChecked(true) end)
		b = CreateFrame("BUTTON", "MageTaxi_Port"..i, f, "SecureActionButtonTemplate")
			b:SetPoint("RIGHT", "MageTaxi_City"..i, "LEFT", 0, 0)
			b:SetHeight(18)
			b:SetWidth(18)
			b.texture = b:CreateTexture("MageTaxi_Spell"..i)
				b.texture:SetAllPoints(b)
				b.texture:SetTexture("Interface\\Icons\\Spell_Arcane_Portal".. cityList[i])
			b:SetAttribute("type", "spell")
			b:SetAttribute("spell", "Portal: ".. cityList[i])
		fs = b:CreateFontString("MageTaxi_Text"..i)
			fs:SetFontObject("GameFontNormalSmall")
			fs:SetJustifyH("LEFT")
			fs:SetText(gsub(cityList[i], "([a-z]+)([A-Z][a-z]+)", "%1 %2"))
			fs:SetPoint("LEFT", "MageTaxi_City"..i, "RIGHT", 0,0)
	end
	
	-- PRICE INFO -- 
	local fs = f:CreateFontString("MageTaxi_PriceLabel")
		fs:SetFontObject("GameFontNormalSmall")
		fs:SetJustifyH("LEFT")
		fs:SetWidth(32)
		fs:SetText("Price:")
		fs:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 10,36)
		
	local e = CreateFrame("EditBox", "MageTaxi_PriceBox", f)
		e:SetWidth(40)
		e:SetHeight(18)
		e:SetPoint("LEFT", MageTaxi_PriceLabel, "RIGHT", 0,-2)
		e:SetBackdrop({
			bgFile="",
			edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
			tile="true",
			tileSize= 32,
			edgeSize=10,
			insets = {left=5, right=5, top=5, bottom=5}
		})
		e:SetAutoFocus(false)
		e:SetTextInsets(5,0,0,0)
		e:SetFontObject("GameFontBlackSmall")
		e:SetMaxLetters(4)
		e:SetText(MageTaxi_Vars.price)
		e:SetScript("OnEnterPressed", function(self) MageTaxi_Vars.price = tonumber(self:GetText()) self:ClearFocus() end)
		e:SetScript("OnEscapePressed", e.ClearFocus)
		e:SetScript("OnTabPressed", function(self) MageTaxi_TravelBox:SetFocus() MageTaxi_Vars.price = tonumber(self:GetText()) end)
	
	-- TRAVEL PRICE --
	fs = f:CreateFontString("MageTaxi_TravelLabel")
		fs:SetFontObject("GameFontNormalSmall")
		fs:SetJustifyH("LEFT")
		fs:SetWidth(40)
		fs:SetText("Travel:")
		fs:SetPoint("LEFT", MageTaxi_PriceBox, "RIGHT", 6,2)
		
	e = CreateFrame("EditBox", "MageTaxi_TravelBox", f)
		e:SetWidth(40)
		e:SetHeight(18)
		e:SetPoint("LEFT", MageTaxi_TravelLabel, "RIGHT", 0,-2)
		e:SetBackdrop({
			bgFile="",
			edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
			tile="true",
			tileSize= 32,
			edgeSize=10,
			insets = {left=5, right=5, top=5, bottom=5}
		})
		e:SetAutoFocus(false)
		e:SetTextInsets(5,0,0,0)
		e:SetFontObject("GameFontBlackSmall")
		e:SetMaxLetters(4)
		e:SetText(MageTaxi_Vars.travel)
		e:SetScript("OnEnterPressed", function(self) MageTaxi_Vars.travel = tonumber(self:GetText()) self:ClearFocus() end)
		e:SetScript("OnEscapePressed", e.ClearFocus)
		e:SetScript("OnTabPressed", function(self) MageTaxi_AddBox:SetFocus() MageTaxi_Vars.travel = tonumber(self:GetText()) end)
		
	-- ADDITIONAL PERSONS --
	fs = f:CreateFontString("MageTaxi_AddLabel")
		fs:SetFontObject("GameFontNormalSmall")
		fs:SetJustifyH("LEFT")
		fs:SetWidth(30)
		fs:SetText("Add:")
		fs:SetPoint("LEFT", MageTaxi_TravelBox, "RIGHT", 6,2)
		
	e = CreateFrame("EditBox", "MageTaxi_AddBox", f)
		e:SetWidth(40)
		e:SetHeight(18)
		e:SetPoint("LEFT", MageTaxi_AddLabel, "RIGHT", 0,-2)
		e:SetBackdrop({
			bgFile="",
			edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
			tile="true",
			tileSize= 32,
			edgeSize=10,
			insets = {left=5, right=5, top=5, bottom=5}
		})
		e:SetAutoFocus(false)
		e:SetTextInsets(5,0,0,0)
		e:SetFontObject("GameFontBlackSmall")
		e:SetMaxLetters(4)
		e:SetText(MageTaxi_Vars.add)
		e:SetScript("OnEnterPressed", function(self) MageTaxi_Vars.add = tonumber(self:GetText()) self:ClearFocus() end)
		e:SetScript("OnEscapePressed", e.ClearFocus)
		e:SetScript("OnTabPressed", function(self) MageTaxi_PriceBox:SetFocus() MageTaxi_Vars.add = tonumber(self:GetText()) end)
		
		
	-- DISABLE UNKNOWN SPELLS --
	for i = 1, #cityList do
		local noUsable = 0
		-- make sure to compensate for "Thunder Bluff" and "Tol Barad"
		local usable = IsUsableSpell("Portal: ".. gsub(cityList[i], "([a-z]+)([A-Z][a-z]+)", "%1 %2")) 
		if (not usable) then
			_G["MageTaxi_City"..i]:Disable()
			_G["MageTaxi_Port"..i]:Disable()
			_G["MageTaxi_Text"..i]:SetAlpha(.2)
			noUsable = noUsable + 1
		end
		
		if (noUsable == #cityList) then
			dest = "none"
		end
	end
end
